import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "nQVQPOOOOQO'#Cf'#CfOOQO'#Cb'#CbQVQPOOOOQO-E6`-E6`",
  stateData: "e~OXOS~OQPORPOSPOTPO~O",
  goto: "fZPPPPPP[PPPbQRORSRTQOR",
  nodeNames: "⚠ Program Identifier String CallExpression Operator",
  maxTerm: 10,
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "+o~RnXY#PYZ#P]^#Ppq#Prs#bwx#bz{%|{|%|}!O%|!P!Q%|!Q![&R!c!d&W!d!e&R!e!f&k!f!g([!g!h&R!h!i)V!i!k&R!k!l)q!l!o&R!o!p)y!p!q*e!q!r*s!r!t&R!t!u*{!u!{&R!{!|+a!|!}&R#R#S&R#T#o&R~#USX~XY#PYZ#P]^#Ppq#P~#eXOr#brs$Qsw#bwx$Vx#O#b#O#P$w#P;'S#b;'S;=`%v<%lO#b~$VOR~~$[XR~Or#brs$Qsw#bwx$Vx#O#b#O#P$w#P;'S#b;'S;=`%v<%lO#b~$zRO;'S#b;'S;=`%T;=`O#b~%WYOr#brs$Qsw#bwx$Vx#O#b#O#P$w#P;'S#b;'S;=`%v;=`<%l#b<%lO#b~%yP;=`<%l#b~&ROT~~&WOQ~~&]PQ~!p!q&`~&cP!f!g&f~&kOS~~&pQQ~!g!h&v!q!r'S~&yP!k!l&|~'PP!n!o&f~'VP!p!q'Y~']P!e!f'`~'cP!c!d'f~'iP!v!w'l~'oP!g!h'r~'uP!p!q'x~'{P!c!d(O~(RP!v!w(U~(XP!g!h&f~(aPQ~!c!d(d~(gQ!v!w(m!{!|&f~(pP!g!h(s~(vP!f!g(y~(|P!k!l)P~)SP!h!i&f~)[PQ~!n!o)_~)bP!q!r)e~)hP!q!r)k~)nP!t!u&f~)vPQ~!h!i&f~*OPQ~!q!r*R~*UP!p!q*X~*[P!v!w*_~*bP!j!k&f~*jPQ~!q!r*m~*pP!y!z&f~*xPQ~!t!u&f~+QPQ~!q!r+T~+WP!w!x+Z~+^P!p!q&`~+fPQ~!g!h+i~+lP!c!d)k",
  tokenizers: [0],
  topRules: {"Program":[0,1]},
  tokenPrec: 0
});

const CYBER_FORMULA_Language = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({}),
            styleTags({
                CallExpression: tags.keyword,
                Identifier: tags.variableName,
                String: tags.string,
                Operator: tags.operator,
                "( )": tags.paren
            })
        ]
    }),
    languageData: {}
});
function cyberFormula() {
    return new LanguageSupport(CYBER_FORMULA_Language);
}

export { CYBER_FORMULA_Language, cyberFormula };
